package fr.velossity.sample.device.impl;

import java.util.Dictionary;
import java.util.Hashtable;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.service.event.Event;
import org.osgi.service.event.EventConstants;
import org.osgi.service.event.EventHandler;

/**
 * 
 * @author C. Saint-Marcel
 * 
 */
public class Activator implements BundleActivator, EventHandler {

	/**
	 * @see BundleActivator#start(BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		// Service class name
		String clazz = EventHandler.class.getName();

		Dictionary dico = new Hashtable();  
		dico.put(EventConstants.EVENT_TOPIC, new String[]{"fr/velossity/measures/*"}); 
		
		// PUBLISHES the event handler service
		context.registerService(clazz, this, dico);

	}

	/**
	 * @see BundleActivator#stop(BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
	}

	/**
	 * @see EventHandler#handleEvent(Event)
	 */
	public void handleEvent(Event event) {
		String identifier = event.getProperty("identifier").toString();
		String value = event.getProperty("value").toString();
		String unit = event.getProperty("unit").toString();
		System.out.println("New measure [" + identifier + "]= " + value + " " + unit);		
	}

}
